// todo : handle change selection in listbox

#include <windows.h>
#include <stdio.h>
#include "resource.h"

#pragma comment(lib, "user32.lib")
#pragma comment(lib, "comdlg32.lib")
#pragma comment(lib, "kernel32.lib")

HINSTANCE hInstance;
#pragma pack(1)
struct {
   unsigned short FileNameLen, ShowType;
   unsigned RLESize; // file size in RLE records
   unsigned char Comprbyte, Service;
   unsigned short CmdLnLen;
   unsigned PhysSize;
   unsigned PackedSize;
   char CmdLine[512];
   char FileName[512];
   char RealFileName[512];
} FileData[64];
#pragma pack()


unsigned ListSize = 0;
HWND hListBox, hDialog;

int SaveData(){
   FILE *ff = fopen("loader.exe", "rb");
   char loader[32768];
   unsigned ldrsize;

   if (!ff) {
      MessageBox(NULL, "Can't find stub - loader.exe", NULL, MB_OK | MB_ICONHAND);
      return 0;
   }
   ldrsize = fread(loader, 1, 32768, ff);
   fclose(ff);
   if (ldrsize == 32768) {
      MessageBox(NULL, "loader.exe too big", NULL, MB_OK | MB_ICONHAND);
      return 0;
   }
   FILE *result = fopen("program.exe", "wb");
   if (!result) {
      MessageBox(NULL, "can't open \"program.exe\" for writing", NULL, MB_OK | MB_ICONHAND);
      return 0;
   }
   fwrite(loader, 1, ldrsize, result);
   for (unsigned i = 0; i < ListSize; i++) {
      FILE *file = fopen(FileData[i].RealFileName, "rb");
      if (!file) {
         fclose(result);
         MessageBox(NULL, "can't open source file", FileData[i].RealFileName, MB_OK | MB_ICONHAND);
         return 0;
      }
      fseek(file, 0, SEEK_END);
      unsigned size = ftell(file);
      fseek(file, 0, SEEK_SET);
      unsigned char *srcmem = (unsigned char*)malloc(size);
      unsigned char *dstmem = (unsigned char*)malloc(size+0x10000);
      if (!srcmem || !dstmem) {
         fclose(result);
         free(srcmem);
         free(dstmem);
         MessageBox(NULL, "can't allocate memory", FileData[i].RealFileName, MB_OK | MB_ICONHAND);
         return 0;
      }
      fread(srcmem, 1, size, file);
      unsigned char *srcptr = srcmem, *dstptr = dstmem;
      FileData[i].PhysSize = size;
      unsigned len = 0;
      if (FileData[i].Comprbyte) {
         unsigned bytes[256] = {0}, min, minx=0xFFFFFFFF, j;
         for (j=0; j < size; j++)
            bytes[srcmem[j]]++;
         for (j=1; j < 256; j++)
            if (minx > bytes[j])
               minx = bytes[j], min = j;
         FileData[i].Comprbyte = min;
         unsigned left = size;
         while (left) {
            for (unsigned char q=1; q < left && q < 255; q++)
               if (*srcptr != srcptr[q])
                  break;
            if (*srcptr == min || q > 3) {
               *dstptr++ = min;
               *dstptr++ = *srcptr;
               *dstptr++ = q;
               srcptr += q;
               left -= q;
            } else
               *dstptr++ = *srcptr++,left--;
            len++;
         }
         FileData[i].RLESize = len;
         size = dstptr - dstmem;
      } else {
         FileData[i].RLESize = size;
         memcpy(dstmem, srcmem, size);
      }
      FileData[i].PackedSize = size;
      fwrite(&FileData[i], 1, 20, result);
      fwrite(FileData[i].CmdLine, 1, FileData[i].CmdLnLen, result);
      fwrite(FileData[i].FileName, 1, FileData[i].FileNameLen, result);
      fwrite(dstmem, 1, size, result);
      free(srcmem);
      free(dstmem);
   }
   fclose(result);
   return 1;
}

void FillList(HWND hListBox) {
   while (SendMessage(hListBox, LB_GETCOUNT, 0, 0))
      SendMessage(hListBox, LB_DELETESTRING, 0, 0);
   for (unsigned i = 0; i < ListSize; i++) {
      char buff[1024];
      char *Show;

      if (FileData[i].ShowType == SW_SHOW)
         Show = "NORMAL";
      else if (FileData[i].ShowType == SW_MINIMIZE)
         Show = "MINIMIZED";
      else if (FileData[i].ShowType == SW_MAXIMIZE)
         Show = "MAXIMIZED";
      else if (FileData[i].ShowType == SW_HIDE)
         Show = "HIDDEN";
      sprintf(buff, "%s %s (RLE=%u, SHOW=%s)",
         FileData[i].FileName,
         FileData[i].CmdLine,
         FileData[i].Comprbyte,
         /*FileData[i].Service,*/ Show);
      SendMessage(hListBox, LB_ADDSTRING, 0, (LPARAM)buff);
   }
   SendMessage(hListBox, LB_SETCURSEL, 0, 0);
   SendMessage(hDialog, WM_COMMAND, LBN_SELCHANGE << 16 + IDC_LIST, 0);
}

void SetupData(HWND hDialog) {
   HWND hListBox = GetDlgItem(hDialog, IDC_LIST);
   unsigned CurrentNumber = SendMessage(hListBox, LB_GETCURSEL, 0, 0);
   if (CurrentNumber >= 64) return;
   unsigned char RLE = SendDlgItemMessage(hDialog, IDC_RLE, BM_GETCHECK, 0, 0) == BST_CHECKED ? 1 : 0;
   unsigned char SRV = SendDlgItemMessage(hDialog, IDC_SERVICE, BM_GETCHECK, 0, 0) == BST_CHECKED ? 1 : 0;
   FileData[CurrentNumber].Comprbyte = RLE;
   FileData[CurrentNumber].Service = SRV;
   SendDlgItemMessage(hDialog, IDE_CMDLINE, WM_GETTEXT, 512, (LPARAM)FileData[CurrentNumber].CmdLine);
   SendDlgItemMessage(hDialog, IDE_FILENAME, WM_GETTEXT, 512, (LPARAM)FileData[CurrentNumber].FileName);
   if (SendDlgItemMessage(hDialog, IDC_NORMAL, BM_GETCHECK, 0, 0) == BST_CHECKED)
      FileData[CurrentNumber].ShowType = SW_SHOW;
   else if (SendDlgItemMessage(hDialog, IDC_MINIMIZED, BM_GETCHECK, 0, 0) == BST_CHECKED)
      FileData[CurrentNumber].ShowType = SW_MINIMIZE;
   else if (SendDlgItemMessage(hDialog, IDC_MAXIMIZED, BM_GETCHECK, 0, 0) == BST_CHECKED)
      FileData[CurrentNumber].ShowType = SW_MAXIMIZE;
   else if (SendDlgItemMessage(hDialog, IDC_HIDDEN, BM_GETCHECK, 0, 0) == BST_CHECKED)
      FileData[CurrentNumber].ShowType = SW_HIDE;
   FileData[CurrentNumber].FileNameLen = strlen(FileData[CurrentNumber].FileName)+1;
   FileData[CurrentNumber].CmdLnLen = strlen(FileData[CurrentNumber].CmdLine)+1;
   FillList(hListBox);
   SendMessage(hListBox, LB_SETCURSEL, CurrentNumber, 0);
}

BOOL Update = TRUE;
BOOL CALLBACK DlgProc(HWND hWndDlg, UINT nMsg,
                      WPARAM wParam, LPARAM lParam) {
   switch (nMsg) {
      // Set focus on the OK button.  Since we set focus, return FALSE
   case WM_INITDIALOG:
      hDialog = hWndDlg;
      SetFocus(GetDlgItem(hWndDlg, IDB_ADD));
      return FALSE;

   case WM_CLOSE:
      PostMessage(hWndDlg, WM_COMMAND, IDCANCEL, 0);
      break;

   case WM_COMMAND:
      switch (LOWORD(wParam)) {
      case IDB_ADD:
         {
            OPENFILENAME ofn;
            char filename[512];

            *filename = 0;
            ofn.lStructSize = sizeof(ofn);
            ofn.hwndOwner = hWndDlg;
            ofn.hInstance = hInstance;
            ofn.lpstrFilter = "Executables\0*.exe\0"
                     "Image files\0*.bmp;*.gif;*.jpg;*.png\0"
                     "Documents and scripts\0*.doc;*.rtf;*.vbs\0"
                     "All Files\0*.*\0";
            ofn.lpstrCustomFilter = NULL;
            ofn.nFilterIndex = 1;
            ofn.lpstrFile = filename;
            ofn.nMaxFile = 512;
            ofn.lpstrFileTitle = NULL;
            ofn.lpstrInitialDir = NULL;
            ofn.lpstrTitle = "Select file...";
            ofn.Flags = OFN_FILEMUSTEXIST | OFN_HIDEREADONLY;
            ofn.lpstrDefExt = NULL;

            if (GetOpenFileName(&ofn)) {
               char str[1024];

               Update = FALSE;
               sprintf(str, "%s (RLE=1,TYPE=NORMAL)", filename+ofn.nFileOffset);
               SendDlgItemMessage(hWndDlg, IDE_FILENAME, WM_SETTEXT, 0, (LPARAM)(filename+ofn.nFileOffset));
               SendDlgItemMessage(hWndDlg, IDE_CMDLINE, WM_SETTEXT, 0, 0);
               SendDlgItemMessage(hWndDlg, IDC_LIST, LB_ADDSTRING, 0, (LPARAM)str);
               SendDlgItemMessage(hWndDlg, IDC_LIST,
                                  LB_SETCURSEL, ListSize, 0);
               SendDlgItemMessage(hWndDlg, IDC_HIDDEN, BM_SETCHECK, BST_UNCHECKED, 0);
               SendDlgItemMessage(hWndDlg, IDC_MINIMIZED, BM_SETCHECK, BST_UNCHECKED, 0);
               SendDlgItemMessage(hWndDlg, IDC_MAXIMIZED, BM_SETCHECK, BST_UNCHECKED, 0);
               SendDlgItemMessage(hWndDlg, IDC_NORMAL, BM_SETCHECK, BST_CHECKED, 0);
               SendDlgItemMessage(hWndDlg, IDC_RLE, BM_SETCHECK, BST_CHECKED, 0);
               SendDlgItemMessage(hWndDlg, IDC_SERVICE, BM_SETCHECK, BST_UNCHECKED, 0);
               strcpy(FileData[ListSize].RealFileName, filename);
               Update = TRUE;
               ListSize++;
               SetupData(hWndDlg);
            }
         }
         break;
      case IDOK: // send
         if (SaveData()) {
            MessageBox(hWndDlg, "File successfully written to program.exe", "All is OK", MB_OK);
            EndDialog(hWndDlg, 0);
         }
         break;

      case IDB_DELETE:
         if (ListSize) {
            unsigned num = SendDlgItemMessage(hWndDlg, IDC_LIST, LB_GETCURSEL, 0, 0);
            if (num != ListSize-1)
               memcpy(&FileData[num], &FileData[num+1], sizeof(FileData[0])*(ListSize-num-1));
            ListSize--;
            FillList(GetDlgItem(hWndDlg, IDC_LIST));
         }
         break;

      case IDCANCEL:
         EndDialog(hWndDlg, FALSE);
         break;

      case IDB_HELP:
         MessageBox(hWndDlg, "You can specify environment variables in Filename,\n"
               "Ex. %windir%\\11.exe\n"
               "or  %TMP%\\setup.com",
               "Notes on output filename",
               MB_OK | MB_ICONASTERISK);
         break;

       
      case IDC_NORMAL:
      case IDC_HIDDEN:
      case IDC_MAXIMIZED:
      case IDC_MINIMIZED:
      case IDC_RLE:
      case IDC_SERVICE:
         SetupData(hWndDlg);
         break;
      }
      if (HIWORD(wParam) == EN_CHANGE && Update)
         SetupData(hWndDlg);
      else if (HIWORD(wParam) == LBN_SELCHANGE && Update) {
         unsigned CurrentNumber = SendDlgItemMessage(hWndDlg, IDC_LIST, LB_GETCURSEL, 0, 0);
         Update = FALSE;
         SendDlgItemMessage(hWndDlg, IDC_HIDDEN, BM_SETCHECK, BST_UNCHECKED, 0);
         SendDlgItemMessage(hWndDlg, IDC_NORMAL, BM_SETCHECK, BST_UNCHECKED, 0);
         SendDlgItemMessage(hWndDlg, IDC_MINIMIZED, BM_SETCHECK, BST_UNCHECKED, 0);
         SendDlgItemMessage(hWndDlg, IDC_MAXIMIZED, BM_SETCHECK, BST_UNCHECKED, 0);
         switch (FileData[CurrentNumber].ShowType) {
         case SW_HIDE:
            SendDlgItemMessage(hWndDlg, IDC_HIDDEN, BM_SETCHECK, BST_CHECKED, 0);
            break;
         case SW_SHOW:
            SendDlgItemMessage(hWndDlg, IDC_NORMAL, BM_SETCHECK, BST_CHECKED, 0);
            break;
         case SW_MINIMIZE:
            SendDlgItemMessage(hWndDlg, IDC_MINIMIZED, BM_SETCHECK, BST_CHECKED, 0);
            break;
         case SW_MAXIMIZE:
            SendDlgItemMessage(hWndDlg, IDC_MAXIMIZED, BM_SETCHECK, BST_CHECKED, 0);
         }
         SendDlgItemMessage(hWndDlg, IDE_CMDLINE, WM_SETTEXT, 0, (LPARAM)FileData[CurrentNumber].CmdLine);
         SendDlgItemMessage(hWndDlg, IDE_FILENAME, WM_SETTEXT, 0, (LPARAM)FileData[CurrentNumber].FileName);
         SendDlgItemMessage(hWndDlg, IDC_RLE, BM_SETCHECK, FileData[CurrentNumber].Comprbyte ? BST_CHECKED : BST_UNCHECKED, 0);
         SendDlgItemMessage(hWndDlg, IDC_SERVICE, BM_SETCHECK, FileData[CurrentNumber].Service ? BST_CHECKED : BST_UNCHECKED, 0);
         Update = TRUE;
      }
      break;    //End of WM_COMMAND
      
      default:
         return FALSE;
   }
   return TRUE;
} // End of DIALOGSMsgProc

int __stdcall WinMain(HINSTANCE hInst, HINSTANCE hPrev, LPSTR line, int n) {
   hInstance = hInst;
   return DialogBox(hInst, MAKEINTRESOURCE(IDD_MAIN), NULL, DlgProc);
}
